package ms.warpzone.warppay.dialogs;

import android.app.Dialog;
import android.os.Bundle;
import android.text.InputType;
import android.view.KeyEvent;
import android.view.View;
import android.view.Window;
import android.widget.Button;
import android.widget.EditText;
import android.widget.NumberPicker;

import java.math.BigDecimal;

import ms.warpzone.warppay.MainActivity;
import ms.warpzone.warppay.R;
import ms.warpzone.warppay.manager.MainManager;

public class ChargeCustomDialog extends Dialog implements
        View.OnClickListener, View.OnKeyListener {

    private MainActivity c;
    private Dialog d;
    private Button btnCustomCharge;
    private EditText etxtAmount;

    public ChargeCustomDialog(ChargeDialog dialog, MainActivity a) {
        super(a);
        dialog.dismiss();
        this.c = a;
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        requestWindowFeature(Window.FEATURE_NO_TITLE);
        setContentView(R.layout.charge_custom_dialog);

        this.etxtAmount = (EditText) findViewById(R.id.etxtCustomAmount);
        //this.etxtAmount.setInputType(InputType.TYPE_CLASS_NUMBER);
        this.etxtAmount.setOnKeyListener(this);

        this.btnCustomCharge = (Button) findViewById(R.id.btnCustomCharge);

        this.btnCustomCharge.setOnClickListener(this);

    }

    @Override
    public void onClick(View v) {

        switch (v.getId()) {
            case R.id.btnCustomCharge:
                this.chargeAmount();
                break;
            default:
                break;
        }

        this.etxtAmount.setEnabled(false);
        dismiss();
    }

    private void chargeAmount() {
        try {
            String text = this.etxtAmount.getText().toString();
            text = text.replace(",",".");
            BigDecimal amount = BigDecimal.valueOf(Double.valueOf(text));
            if(amount.compareTo(new BigDecimal(0.0)) > 0)
                MainManager.getInstance().chargeAmount(amount);
        } catch (Exception e) {

        }
    }
    @Override
    public boolean onKey(View view, int i, KeyEvent keyEvent) {
        if (KeyEvent.KEYCODE_ENTER == keyEvent.getKeyCode()) {
            this.chargeAmount();
        }
        return false;
    }
}
