package ms.warpzone.warppay.manager;

import android.content.Context;

import com.squareup.okhttp.Interceptor;
import com.squareup.okhttp.OkHttpClient;
import com.squareup.okhttp.Request;

import java.io.IOException;
import java.security.KeyManagementException;
import java.security.KeyStore;
import java.security.KeyStoreException;
import java.security.NoSuchAlgorithmException;
import java.security.cert.CertificateException;

import javax.net.ssl.SSLContext;
import javax.net.ssl.TrustManagerFactory;

import ms.warpzone.warppay.R;
import ms.warpzone.warppay.data.RestService;
import retrofit.GsonConverterFactory;
import retrofit.Retrofit;

public class RestManager {
    private static RestManager ourInstance = new RestManager();
    RestService restService;

    private RestManager() {}
    public static RestManager getInstance() {
        return ourInstance;
    }

    public void initRestService() {
        this.restService = this.createRestService();
    }

    public RestService getRestService() {
        return restService;
    }

    private RestService createRestService() {
        Retrofit.Builder builder = new Retrofit.Builder()
                .baseUrl("http://infra-test.warpzone/api/")
                .addConverterFactory(GsonConverterFactory.create());

        OkHttpClient okHttp = new OkHttpClient();
        try {
            okHttp.setSslSocketFactory(getSSLConfig(MainManager.getInstance().getMainActivity().getBaseContext()).getSocketFactory());
            okHttp.networkInterceptors().add(new Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(Chain chain) throws IOException {
                    Request request = chain.request();
                    Request newRequest;

                    newRequest = request.newBuilder()
                            .addHeader("Authorization", "Token cdcca01b29316e993477b32f1a86274804318fa0")
                            .build();

                    return chain.proceed(newRequest);
                }
            });
        } catch (CertificateException | NoSuchAlgorithmException | KeyManagementException | IOException | KeyStoreException e) {
            e.printStackTrace();
        }

        Retrofit retrofit = builder.client(okHttp).build();
        return retrofit.create(RestService.class);
    }



    private static SSLContext getSSLConfig(Context context) throws CertificateException, IOException,
            KeyStoreException, NoSuchAlgorithmException, KeyManagementException {

        String password = "e44r4dv9z1d0vwr9erotafxe66114v31jwhjlvttc8qkoa3nrskcj4ml0pwrh8aw";
        KeyStore keyStore   = KeyStore.getInstance("BKS");
        keyStore.load(context.getResources().openRawResource(R.raw.keystore_old), password.toCharArray());

        String tmfAlgorithm = TrustManagerFactory.getDefaultAlgorithm();
        TrustManagerFactory tmf = TrustManagerFactory.getInstance(tmfAlgorithm);
        tmf.init(keyStore);

        SSLContext sslContext = SSLContext.getInstance("TLS");
        sslContext.init(null, tmf.getTrustManagers(), null);

        return sslContext;
    }
}
